package ISkins;

$VIRSION = '1.0';

#===============================================================================
# CONSTRUCTOR
# indicate path with templates and how to load template
#		$obj = new ISkins($path_to_directory_with_html_templates);
# or
#		$obj = new ISkins();
#		$obj->{'templatesdir'} = './templates/';
#===============================================================================
sub new
{
    my($pkg) = shift;
    my($templatesdir) = shift;
    my($self) = {};
    bless $self, $pkg;
    # directory with HTML templates
    $self->{'templatesdir'} = $templatesdir;
    return $self;
}

#===============================================================================
#	load indicated templates
#		$obj->LoadTemplates(@file_names);
#	scan directory with templates and load all with shown extensions
#		$obj->LoadTemplates();
#===============================================================================
sub LoadTemplates
{
		my($self) = shift;
		my(@files) = @_;
		local *FILE;
		local *DIR;
		# return error if directory not specified
		return $self->setError(q{To init module use : $obj = new ISkins('./templates_directory/') or $obj = new ISkins();	$obj->{'templatesdir'} = './templates_directory/';}) if !defined $self->{'templatesdir'};
		# return error if directory do not exist
		return $self->setError("$! : $self->{'templatesdir'}") if !-d $self->{'templatesdir'};
		# scan directory if @files not defined
		if (!defined @files)
		{
			opendir (DIR, $self->{'templatesdir'});
			while (my $file = readdir(DIR)) { push @files, $file if $file ne '.' and $file ne '..' and $file =~ /$self->{'templatesext'}$/ and !-d $file; }
			closedir(DIR);
		};
		# return error if no files
		return $self->setError("Directory is empty : $self->{'templatesdir'}") if !defined @files;
		foreach my $file(@files)
		{
			open (FILE, "$self->{'templatesdir'}$file") || return $self->setError("$! : $self->{'templatesdir'}$file");
			$self->{$file} = join '', <FILE> if $self->{'loadinmemory'};
			close(FILE);
		};
    return 0;
}

#===============================================================================
#	parse and return template $template_filename 
# @text used to parse template
# 	$obj->Template($template_filename, @text);
#===============================================================================
sub Template
{
		my($self) = shift;
		my($template_filename) = shift;
		$template_filename .= $self->{'templatesext'};
		$template_filename =~ /^([^.]+)/;
		my @text = @_ if @_;
		my($error, $template)=();
		local *FILE;
		# if template do not loaded in memory, load it now
		if (!$self->{'loadinmemory'})
		{
			open (FILE, "$self->{'templatesdir'}$template_filename") || { $error = "$! : $self->{'templatesdir'}$template_filename" };
			$template = join '', <FILE>;
			close(FILE);
		}
		# template already loaded in memory
		else
		{
			$template = $self->{$template_filename};
		}
		# set error if template not defined
		if (!defined $template) { $error = "No such template loaded : $template_filename"; }
		# parse [%key_word%] keys
		$template =~ s/\[\%(\w+)\%\]/$self->{$1}/g;
		# eval template (to replace $text[]) and set error if occured
		eval('$template = qq{'.$template.'}');
		$error = "Can not evat template $template_filename : $@" if $@;
		($error)?(return $error):(return $template);
}

#===============================================================================
# set errorstring in $self->{'error'} and return -1
#		$obj->setError($errormessage);
#===============================================================================
sub setError
{
    my($self)     = shift;
    my($errorMsg) = shift;
    $self->{'error'} = $errorMsg if $errorMsg !~ /^\s*$/;
    return -1;
}

1;

